﻿using Infragistics.Controls.Schedules;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamGanttApp.DataSource
{
    public class ProjectDataHelper
    {
        public static Project GenerateProjectData()
        {
            // Create a project
            Project project = new Project();

            ProjectTask rootTask = new ProjectTask
            {
                TaskName = "Main Summary Task",
                IsManual = false
            };

            project.RootTask.TaskName = "Project Summary Task";
            project.RootTask.Tasks.Add(rootTask);

            // Dates are saved in UTC in xamGantt
            DateTime startTime = DateTime.Today.ToUniversalTime();

            // Add tasks to the root task
            rootTask.Tasks.Add(new ProjectTask
            {
                TaskName = "Planning Task",
                IsManual = false,
                Start = startTime,
                Duration = TimeSpan.FromHours(8),
                Notes = "Planning Note"
            });

            rootTask.Tasks.Add(new ProjectTask
            {
                TaskName = "Document Task",
                IsManual = false,
                Start = startTime,
                ManualDuration = ProjectDuration.FromFormatUnits(2, ProjectDurationFormat.Days),
                ConstraintDate = DateTime.Today.AddDays(3).ToUniversalTime(),
                ConstraintType = ProjectTaskConstraintType.FinishNoLaterThan,
                Notes = "Document Note"
            });

            rootTask.Tasks.Add(new ProjectTask
            {
                TaskName = "Create Application Task",
                IsManual = false,
                Start = startTime,
                ManualDuration = ProjectDuration.FromFormatUnits(3, ProjectDurationFormat.Days),
                ConstraintType = ProjectTaskConstraintType.MustStartOn,
                ConstraintDate = DateTime.Today.AddDays(2).ToUniversalTime(),
                IsEstimated = true,
                Notes = "Demo notes"
            });

            for (int i = 0; i < 20; i++)
            {
                rootTask.Tasks.Add(new ProjectTask
                {
                    TaskName = "Create Application Task" + (i + 2),
                    IsManual = false,
                    Start = startTime,
                    ManualDuration = ProjectDuration.FromFormatUnits(3, ProjectDurationFormat.Days),
                    ConstraintType = ProjectTaskConstraintType.MustStartOn,
                    ConstraintDate = DateTime.Today.AddDays(2).ToUniversalTime(),
                    IsEstimated = true,
                    Notes = "Demo notes"
                });
            }            

            return project;
        }        
    }
}
