﻿using Infragistics.Controls.Schedules;
using XamGanttApp.DataSource;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamGanttApp.ViewModel
{
    public class ProjectViewModel : ObservableModel
    {
        public ProjectViewModel()
        {
            this._project = ProjectDataHelper.GenerateProjectData();
        }

        private Project _project;
        public Project Project
        {
            get
            {
                return this._project;
            }
            set
            {
                if (this._project != value)
                {
                    this._project = value;
                    this.NotifyPropertyChanged("Project");
                }
            }
        }
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}